#=====================================================
# GMBA 7098: Statistics and Data Analaysis, Fall 2014
# Instructor: Ling-Chieh Kung
# Department of Information Management
# National Taiwan University
#=====================================================

#============================ 
# Section 1: The environment
#============================

# Press "Ctrl + R" or "Command + Enter" to execute 
# one or multiple selected statements

getwd()
setwd("C:/Users/user/Documents/11_Courses/__SDA-Fa14/slides/02 descriptive/R")
setwd("C:\\Users\\user\\Documents\\11_Courses\\__SDA-Fa14\\slides\\02 R basics")





#=============================
# Section 2: Basic operations
#=============================

### Direct calculation ###
1 + 2 
5 / 6



### Creating new variables ###
x <- 1
y <- 2
( x <- 1 ) # the assigned value is displayed immediately
( y <- 2 ) 
x + y



### Listing all objects ###
ls()

### Removing an object ###
rm(x)           # then try ls() to see which objects remain
rm(list = ls()) # then try ls() to see which objects remain



### Data types ###

### Boolean (binary) values ###
( b1 <- TRUE ) # "x <- true" does not work!
( b2 <- FALSE )

### Single numbers (scalars) ###
( s1 <- 100 )
( s2 <- 1000.68 )
( s3 <- 3 * 8 )
( s4 <- (s1 + s2) / 2 )

### Characters ###
( c1 <- "Hi" )
( c2 <- "Today is a wonderful day!" )



### Arithmetic ###

### Common operators: +, -, *, /, %%, ^, () ###
10 %% 3      # the remainder of 10 divided by 3
10 ^ 2       # 10 to the power of 2 (10 square)
10 ^ (1 / 2) # 10 to the power of 1/2 (square root of 10)
2 ^ 30
2 ^ 50       # "1.1259e+15" is "1.1259 * 10 ^ 15"
3 + 2 * 5
(3 + 2) * 5

### Common functions ### 
sqrt(16)     # 16 ^ (1 / 2)
factorial(4) # 4 * 3 * 2 * 1
round(10.2)
round(10.6)
floor(10.6)
ceiling(10.2)
abs(-5)

### Some mathematics functions ###
exp(2)       # e ^ 2
log(2)       # log 2 with e as the base
log(2, 2)    # log 2 with 2 as the base 
pi           
sin(pi)      # that just means 0



### Logic operators ###

### ==, <, >, <=, >=, != ###
3 == 2
4 < 6
3.33 != 1 / 3

### |, &, ! ###
TRUE | FALSE
TRUE & TRUE
( b3 <- !TRUE )
b1 | b2
b1 & b2
!b1
TRUE & TRUE & FALSE
any(b1, b2, b3)     # b1 | b2 | b3
all(b1, b2, b3)     # b1 & b2 & b3



### Searching in the manual ###
?log
??log






#====================
# Section 3: Vectors
#====================

### Generating a sequence of numbers ###
( x <- 1:20 )
( x <- 5:-5 )
seq(1, 21, 2)
seq(from = 1, to = 21, by = 2)      # use "=" to assign a value 
seq(from = 1, to = 21, length = 10) # to a function parameter
seq(to = 21, length = 10, from = 1)
rep(2, 5)
rep(1:5, times = 5)
rep(1:5, each = 5)



### Concatenation ###
c(1, 9, 6, 4)
c(5:-5, rep(1:5, times = 2))
c("Hi", "Hello", "Aloha")



### Subscripting (indexing) ###
x[2]
x[-2]
x[c(2, 4)]
x[c(-2, -4)]
which(x >= 1)    # this returns indices, not elements
x[which(x >= 1)] # this returns elements



### Recycling ###
x <- 1:10
x + 2
x - 1:5
x * 1:3



### Logic operators on vectors ###
( bx1 <- x >= 5 )
( bx2 <- x %% 2 == 1 )
bx1 & bx2
bx1 | bx2
!bx1
which(bx1) # index i is returned if bx[i] == TRUE
all(bx1)
any(x >= 5)









#==============================================
# Section 4: Visualizing data with data graphs
#==============================================

### Histogram ###
midtermGrades <- c(
  42, 53, 52, 55, 61, 26, 40, 28, 30, 31, 
  32, 30, 23, 58, 30, 34, 47, 35, 64, 40, 
  57, 49, 25, 52, 60, 30, 50, 30, 49, 74, 
  58, 40, 36, 33, 37, 37, 32, 32, 43, 29, 
  50, 31, 26, 46, 43, 30, 40, 50, 32, 54 
)

hist(midtermGrades)

hist(
  midtermGrades, 
  breaks = seq(from = 20, by = 10, length = 7), 
)

hist(
  midtermGrades, 
  breaks = seq(from = 20, by = 10, length = 7), 
  right = FALSE, 
)

hist(
  midtermGrades, 
  breaks = seq(from = 20, by = 10, length = 7), 
  right = FALSE, 
  main = "Distribution of midterm grades", 
  xlab = "midterm grades", 
  ylim = c(0, 20), 
)
box()

freqMG <- hist(
  midtermGrades, 
  breaks = seq(from = 20, by = 10, length = 7), 
  right = FALSE, 
  plot = FALSE, 
)

freqMG$breaks
freqMG$mids
freqMG$counts



### Frequency ploygon ###
plot(                # try these first
  1:10, 
  rep(1:5, each = 2), 
) 
plot(
  1:10, 
  rep(1:5, each = 2), 
  type = "l", 
) 

plot(
  seq(from = 25, by = 10, length = 6),
  freqMG$counts, 
)

plot(
  seq(from = 25, by = 10, length = 6),
  freqMG$counts, 
  type = "l",
  xlim = c(20, 80), 
)

plot(
  seq(from = 25, by = 10, length = 6),
  freqMG$counts, 
  type = "l",
  main = "Distribution of midterm grades", 
  xlab = "Midterm grades", 
  ylab = "Frequency", 
  xlim = c(20, 80), 
)

plot(
  freqMG$mids,
  freqMG$counts, 
  type = "l",
  main = "Distribution of midterm grades", 
  xlab = "Midterm grades", 
  ylab = "Frequency", 
  xlim = range(freqMG$breaks), 
  lwd = 3, 
)



### Pie chart ###
complaint <- c(280, 105, 98, 70, 147)
comType <- c("Stations", "Equipments", 
             "Personnel", "Schedules", "Trains")
comLabel <- c("Stations (280)", "Equipments (105)", 
              "Personnel (98)", "Schedules (70)", "Trains (147)")
# or do this: 
# comType <- c("Stations", "Equipments", "Personnel", "Schedules", "Trains")
# comLabel <- paste(comType, " (", complaint, ")", sep = "")

pie(
  complaint, 
  comLabel, 
)

pie(
  complaint, 
  comLabel, 
  clockwise = TRUE, 
  main = "Complaints about the railroad system", 
)



### Bar chart ###
barplot(
  complaint, 
  names.arg = comType, 
)

barplot(
  complaint, 
  names.arg = comType, 
  xlab = "Types of complaints", 
  ylim = c(0, 300), 
  main = "Complaints about the railroad system", 
)



### Scatter plot ###
size <- c(75, 59, 85, 65, 72, 46, 107, 91, 75, 65, 88, 59)
price <- c(315, 229, 355, 261, 234, 216, 308, 306, 289, 204, 265, 195)

plot(size, price)

plot(
  size, 
  price, 
  xlim = c(0, 100), 
  ylim = c(0, 400), 
  xlab = "size (m^2)", 
  ylab = "price ($1000)", 
  main = "Sizes and prices of houses"
)





#============================================
# Section 5: Describing data with statistics
#============================================

### central tendency ###
teamHeight <- c(
  178, 172, 175, 184, 172, 175, 165, 178, 177, 175, 
  180, 182, 177, 183, 180, 178, 179, 162, 170, 171
) 

hist(
  teamHeight, 
  breaks = seq(from = 160, to = 188, by = 4), 
  right = FALSE, 
  main = "Distribution of member heights", 
  xlab = "member heights (cm)", 
  freq = TRUE
)
box()

( heightCount <- table(teamHeight) )
heightCount[
  heightCount == max(heightCount)
]
barplot(heightCount)

( medianTH <- median(teamHeight) )

( sumTH <- sum(teamHeight) )

( lenTH <- length(teamHeight) )

( meanTH <- mean(teamHeight) )

quantile(teamHeight)
quantile(teamHeight, 0.2)
quantile(
  teamHeight, 
  c(0.2, 0.99),
)



### Variability ###
range(teamHeight)
max(teamHeight)
min(teamHeight)

( devTH <- teamHeight - meanTH )
sum(devTH)
sum(abs(devTH)) / lenTH # MAD
                        # mad(teamHeight) is NOT 
                        # the mean absolute deviation

var(teamHeight) # sample variance
sd(teamHeight)  # sample standard deviation
sum(devTH ^ 2) / (lenTH - 1)
( pvTH <- var(teamHeight) * (lenTH - 1) / lenTH ) 
                # population variance
sqrt(pvTH)      # population standard deviation

pvTH / meanTH # coefficient of variation



### Correlation ###
( scovPS <- cov(price, size) ) # sample covariance

( lenP <- length(price) )
( pcovPS <- cov(price, size) * (lenP - 1) / lenP ) 
                               # population covariance

( scorPS <- cor(price, size) ) # sample correlation
( ssdP <- sd(price) )
( ssdS <- sd(size) )
scovPS / (ssdP * ssdS)



### summary() ###
summary(price)
summary(teamHeight)




	
#==========
# Appendix
#==========

### Scatter plot with means ###
plot.new()
plot.window(xlim = c(0, 100), ylim = c(0, 400))
points(size, price)
lines(
  x = c(0, 100), 
  y = c(mean(price), mean(price))
)
lines(
  x = c(mean(size), mean(size)), 
  y = c(0, 400)
)
axis(1)
axis(2)
box()

### Population mean vs. sample mean ### 
population <- 1:100
mean(population)

# repeat the following several times
mean(
  population[
    round(
      runif(10) * 100
    )
  ]
)
 




